﻿-- Debuff Monitor

local width, height = 300, 22

--function SN:Debuffs()

--	--make the frames db local
--	local v = SN.db.profile.Frames

--	SN.F.debuffs = SN.timers:NewGroup(300, "DebuffGroup", dbuffgrp)

--	--Check to see if ElvUI is on so we can integrate SN in it better
--	if(IsAddOnLoaded("ElvUI")) then
--		SN.F.debuffs:SetSpacing(0, 7)
--		SN.F.debuffs:SetStartPoint("topleft")
--		SN.F.debuffs:SetPoint(unpack(v.elvdebuffs))
--	else
--		SN.F.debuffs:SetSpacing(0, 3)
--		SN.F.debuffs:SetStartPoint("topleft")
--		SN.F.debuffs:SetPoint(unpack(v.debuffs))
--	end
--	SN.F.debuffs:SetSorting("label")
	
--	SN.F.debuffs:SetScript("OnEvent", function(self, event, ...)
--		SN:UpdateDebuff(self, event, unit, ...)
--	end)
--	SN.F.debuffs:Lock(v.lock)
	
--	--Register our events for this frame
--	SN.F.debuffs:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
--	SN.F.debuffs:RegisterCallback("FancyBar_GroupMove", stored)
--end


--function SN:UpdateDebuff(group, event, unit, ...)
--	if event == "COMBAT_LOG_EVENT_UNFILTERED" then

--		local timestamp, type,_, sourceGUID, sourceName,_,_, destGUID, destName = select(1, ...)
--		local spellId, spellName, spellSchool = select(12, ...)
		
--		for i, cooldown in pairs(SN.db.profile.debuffs) do
--			-- Check to see if the aura is applied and refresh the timer
--			if type == cooldown.refresh then
--				if spellId == cooldown.id then
--					if cooldown.enable then 
--						if sourceGUID == UnitGUID("player") then
--							tempbar = group:Find("SN:arg5", spellName)
--							local _, _, _, _, _, dur = UnitDebuff("target", spellName)
--							--Is there a bar for this debuff already?
--							if tempbar ~= nil then
--								tempbar:SetDuration(dur)
--								tempbar:Start()
--							else
--								--Start a new one because there wasn't
--								SN:CreateBar(group, cooldown, dur, sourceName, destGUID, spellName)
--							end
--						end
--					end
--				end
--			--Start a fresh timer since the aura is not on the target				
--			elseif type == cooldown.succ then
--				if spellId == cooldown.id then
--					if cooldown.enable then
--						if sourceGUID == UnitGUID("player") then
--							local _, _, _, _, _, dur = UnitDebuff("target", spellName)
--							SN:CreateBar(group, cooldown, dur, sourceName, destGUID, spellName)
--						end
--					end
--				end
--			end
--		end
--		--Serpent Sting refresh with Cobra Shot and Chimera Shot
--		if  type == "SPELL_DAMAGE" then
--			if spellId == 77767 or spellId == 53209 then
--				if sourceGUID == UnitGUID("player") then
--					tempbar = group:Find("SN:arg5", "Serpent Sting")
--					if tempbar ~= nil then
--						local _, _, _, _, _, dur = UnitDebuff("target", tempbar:GetData("SN:arg5"))
--						if (tempbar:GetDuration() + 6) > 15 then
--							tempbar:SetDuration(dur)
--						else
--							tempbar:SetDuration(tempbar:GetDuration() + 6)
--						end
--						tempbar:Start()
--					end
--				end
--			end	
--		end
--	end
--end	

function SN:Debuffs()
	
	local f = SN.F
	local m = SN.Media
	--make the frames db local
	local v = SN.db.profile.Frames
	
	f.debuffs = CreateFrame("Frame", DBGroup, UIParent)
	
	if IsAddOnLoaded("ElvUI") then
		f.debuffs:SetPoint(unpack(v.elvdebuffs))
		f.debuffs.startpoint = "topleft"
		f.debuffs.spacing_h = 0
		f.debuffs.spacing_v = 7
	else
		f.debuffs:SetPoint(unpack(v.debuffs))
		f.debuffs.startpoint = "topleft"
		f.debuffs.spacing_h = 0
		f.debuffs.spacing_v = 3
	end
	
	f.debuffs:SetWidth(300)
	f.debuffs:SetHeight(24)
	f.debuffs:SetClampedToScreen(true)
	f.debuffs.frameLocked = 1

	f.debuffs:SetScript("OnEvent", function(self, event, unit, ...)
		SN:UpdateDebuff(self, event, unit, ...)
	end)
	--f.debuffs:Lock(v.lock)
	f.debuffs.sortfield = "label"
	f.debuffs.maxbars = 0
	f.debuffs.bars = {}
	f.debuffs.sortasc = true
	f.debuffs.name = "debuffs"

	f.debuffs.value = f.debuffs:CreateFontString(nil, "ARTWORK")
	f.debuffs.value:SetFont(m.media.font, 24, "OUTLINE")
	f.debuffs.value:SetTextColor(0.78, 0.25, 0.25)
	f.debuffs.value:SetText("")
	f.debuffs.value:SetAllPoints(f.debuffs)
	f.debuffs.value:SetJustifyH("CENTER")
	f.debuffs.value:SetJustifyV("MIDDLE")

	--Register our events for the frame
	f.debuffs:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function SN:UpdateDebuff(frame, event, unit, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then

		local timestamp, type,_, sourceGUID, sourceName,_,_, destGUID, destName = select(1, ...)
		local spellId, spellName, spellSchool = select(12, ...)
		
		for i, cooldown in pairs(SN.db.profile.debuffs) do
			if spellId == cooldown.id then
				if cooldown.enable then
					if sourceGUID == UnitGUID("player") then
						local _, _, _, _, _, dur = UnitDebuff("target", spellName)
						SN:CreateBar(frame, cooldown, dur, sourceName, destGUID, spellName)
					end
				end
			end
		end
	end
end	